#!/usr/bin/python
##################################################################################
#
# Choose pair of sudoku, add them together, and display,
#
# $Id: addSudokuFromWeb.py,v 1.3 2007/01/04 02:22:26 devel Exp $
#
##################################################################################
import cgi
import cgitb; cgitb.enable()
import sys
import os.path

import ConfigParser


from file_opter import file_options
from templategrinder import templateGrinder
from sudoku import A_Sudoku
from palette import A_Palette
from htmlGrinder import Html_Grinder

def display_static(fields):
	sudoku_name_one=fields.getfirst("Sudoku_One_FN")
	sudoku_name_two=fields.getfirst("Sudoku_Two_FN")
	palette_name=fields.getfirst("palette_FN")
	template_name=fields.getfirst("Template_FN")
	my_palette=A_Palette(palette_name,True)
	first_sudoku=A_Sudoku(sudoku_name_one,True)
	twost_sudoku=A_Sudoku(sudoku_name_two,True)
	sum_sudoku = first_sudoku + twost_sudoku
	sudoku_displayer=Html_Grinder(first_sudoku,my_palette)
	templ_dict={}
	templ_dict["Onest"]=sudoku_displayer.return_html(template_name)
	sudoku_displayer.set_sudoku(twost_sudoku)
	templ_dict["Twost"]=sudoku_displayer.return_html(template_name)
	sudoku_displayer.set_sudoku(sum_sudoku)
	templ_dict["Sum"]=sudoku_displayer.return_html(template_name)
	my_grinder=templateGrinder(templ_dict,os.path.join(html_dir,"disp_add_sudoku.html"),True)
	print my_grinder.grind()

def make_animation_array(first,twost):
	# Make base array of 81 generation arrays.
	animation_array=[]
	for ii in range(0,81):
		animation_array.append([]) 
	for ii in range(0,9):
		first.normalize(twost.get_row(ii),ii,"row")
		for jj in range(0,81):
			animation_array[jj].append(first.get_cell(jj))
	for ii in range(0,9):
		first.normalize(twost.get_col(ii),ii,"col")
		for jj in range(0,81):
			animation_array[jj].append(first.get_cell(jj))
		

	return str(animation_array)
#	
# Display animated addition.
#
def display_animation(fields,template_dir):
	sudoku_name_one=fields.getfirst("Sudoku_One_FN")
	sudoku_name_two=fields.getfirst("Sudoku_Two_FN")
	palette_name=fields.getfirst("palette_FN")
	delay_str=fields.getfirst("Delay")
	my_palette=A_Palette(palette_name,True)
	first_sudoku=A_Sudoku(sudoku_name_one,True)
	twost_sudoku=A_Sudoku(sudoku_name_two,True)
	template_dict={}
	template_dict["DELAY"]=delay_str
	animation_array_str=make_animation_array(first_sudoku,twost_sudoku)
	template_dict["GENERATIONS_TABLE"]=animation_array_str
	javascript_palette_str="["
	for jj in range(0,9):
		color_str=my_palette.color_for_number(jj)
		color_str='"'+color_str+'"'
		if jj == 8:
			color_str += "]"
		else:
			color_str += ","
		javascript_palette_str += color_str
	template_dict["PALETTE"]=javascript_palette_str
	my_grinder=templateGrinder(template_dict,os.path.join(template_dir,"animation.jstpl"),True)
	print my_grinder.grind()

#		
# Main Line 
#
myConfig=ConfigParser.ConfigParser()
myConfig.read("web.config")

grinder_dir=myConfig.get("PATHS","storagedir")
template_dir=myConfig.get("PATHS","templatedir")
html_dir=myConfig.get("PATHS","htmldir")

print "Content-type: text/html\n"

if 2 > len(sys.argv):
	template_dict={}
	my_opter=file_options(grinder_dir,"*.sudokuG")
	template_dict["SudokuListOne"]=my_opter.get_option_list()
	template_dict["SudokuListTwo"]=my_opter.get_option_list()
	my_opter.make_file_list(grinder_dir,"*.palette")
	template_dict["PaletteList"]=my_opter.get_option_list()
	my_opter.make_file_list(template_dir,"*.tpl")
	template_dict["TemplateList"]=my_opter.get_option_list()
	my_grinder=templateGrinder(template_dict,os.path.join(html_dir,"add_sudoku.html"),True)
	print my_grinder.grind()
else:
	form_fields=cgi.FieldStorage()
	if form_fields.getfirst("Add"):
		display_static(form_fields)
	if form_fields.getfirst("Animate"):
		display_animation(form_fields,template_dir)

	
