#!/usr/bin/python
###############################################################
#
# Copyright (C) Charles Shapiro 2006 charles.shapiro@tomshiro.org
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2, or (at your option)
#   any later version.
#
# Enter a sudoku object from the web.
#
# $Id: enterSudokuFromWeb.py,v 1.7 2006/05/29 14:09:07 devel Exp $
#
###############################################################
import cgi
import cgitb; cgitb.enable()
import os
import os.path
import re
import sys
import ConfigParser

from filer import filer
from sudoku import A_Sudoku
from templategrinder import templateGrinder
	

def save_sudoku(my_sudoku,saved_template,save_dir):
	"""Save a sudoku to the file system."""
	fnPart=".sudoku"
	sudoku_is_valid=True
	if not my_sudoku.is_solution():
		fnPart += "B"
		sudoku_is_valid=False
	else:
		fnPart += "G"
	my_filer=filer(save_dir,"*"+fnPart)
	(last_filename,isdup)=my_filer.get_next_file(my_sudoku.get_hash())
	if isdup == False:
		filename=os.path.join(save_dir,last_filename)
		my_sudoku.save_to_file(filename)
		my_filer.add_sum_to_listfile(my_sudoku.get_hash(),last_filename)
	last_filenum=my_filer.num_from_fn(last_filename)
	display_dict={}
	display_dict["SudokuNumber"]=str(last_filenum)
	display_dict["ValidMessage"]=" "
	if not sudoku_is_valid:
		display_dict["ValidMessage"]= "<br><b><font color=red>This sudoku is NOT VALID. It will only stay for a little while.</font></b><br>"

	my_grinder=templateGrinder(display_dict,saved_template,True)
	print my_grinder.grind()

def display_html(inpt_sudoku,html_template):
	"""Display html form."""
	display_dict={}
	if not inpt_sudoku:
		display_dict["CurrentContents"]=" "
		display_dict["CurrentValid"]=" "
	else:
		display_dict["CurrentContents"]=str(inpt_sudoku)
		if inpt_sudoku.is_solution():
			display_dict["CurrentValid"]='<b><font color="Green">Valid</font></b>'
		else:
			display_dict["CurrentValid"]='<b><font color="Red">Bad</font></b>'
	my_grinder=templateGrinder(display_dict,html_template,True)
	print my_grinder.grind()


#
# Main Line
#
print "Content-type: text/html\n"

config_reader=ConfigParser.ConfigParser()
config_reader.read("web.config")
htmldir=config_reader.get("PATHS","htmldir")

entry_template=os.path.join(htmldir,"enter_sudoku.html")
saved_template=os.path.join(htmldir,"sudokusaved.html")
save_dir=config_reader.get("PATHS","storagedir")

if len(sys.argv) > 1:
	theForm=cgi.FieldStorage()
	sudoku_str=theForm.getfirst("SudokuText")
	if not sudoku_str:
		display_html(None,entry_template)
	the_sudoku=A_Sudoku(sudoku_str)
	if theForm.getfirst("Validate"):
		display_html(the_sudoku,entry_template)
	if theForm.getfirst("Write"):
		save_sudoku(the_sudoku,saved_template,save_dir)		
else:
	display_html(None,entry_template)