#!/user/bin/python
###############################################################################
#
#
# Copyright (C) Charles Shapiro 2006 charles.shapiro@tomshiro.org
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2, or (at your option)
#   any later version.
#
#
# Make option list from directory, file name (e.g. "*.foo")
#
# $Id: file_opter.py,v 1.4 2006/11/23 14:15:55 devel Exp $
#
##################################################################################
import os
import os.path
import re
import glob
import sys

class file_options:
        def file_name_compare_function(self,name_A, name_B):
     		"""Compare a pair of filenames."""
		num_re=re.compile("[0123456789]+")
		retVal=-1
		if num_re.search(name_A):
			num_one=int(num_re.search(name_A).group())
			num_two=int(num_re.search(name_B).group())
			if num_one > num_two:
				retVal=1
		else:
			if name_A > name_B:
				retVal=1
		return retVal
		
	def setup(self):
		"""Set myself up."""
		self.file_list=[]
		self.file_opt_re=None
		self.ready=False
		self.before=""
		self.after=""

	def __init__(self,dir="",file_glob="",file_opt_re="^[^\.]+"):
		"""Create Myself. Args are dir: dir where files are,
		   file_glob: file name (e.g. \"*.entry\"), file_opt_re:
		   re to make option out of name."""
		self.setup()
		self.file_opt_re=re.compile(file_opt_re)
		if 0 < len(dir) and 0 < len(file_glob):
			self.make_file_list(dir,file_glob)

	def make_file_list(self,dir,file_glob):
		"""Make the file list from which we make the option list."""
		self.file_list=glob.glob(os.path.join(dir,file_glob))
		self.file_list.sort(self.file_name_compare_function)
		self.ready=True

	def is_ready(self):
		return self.ready

	def set_file_opt_re(str):
		self.file_opt_re=re.compile(str)

	def set_before(self,str):
		self.before=str

	def set_after(self,str):
		self.after=str

	def get_option_list(self):
		retVal=""		
		if self.ready:
			for kk in self.file_list:
				(dummy,fn)=os.path.split(kk)
				option_name=self.file_opt_re.search(fn).group()
				opt_str="<option value=%s>%s%s%s</option>\n" % (kk,self.before,option_name,self.after)  
				retVal += opt_str
		return retVal

if __name__ == "__main__":
	file_opter=file_options("../../sudoku_storage","*.sudokuG")
	print file_opter.get_option_list()
	file_opter.set_before("<font color=red>")
	file_opter.set_after("</font>")
	print("----------------------------------------")
	print file_opter.get_option_list()



		
