#!/usr/bin/python
############################################################################
#
# Copyright (C) Charles Shapiro 2006 charles.shapiro@tomshiro.org
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2, or (at your option)
#   any later version.
#
#
# Translate a colored sudoku into an html file.
#
# $Id: htmlGrinder.py,v 1.5 2006/11/24 15:29:55 devel Exp $
#
#############################################################################
import string
import palette
import sudoku
import templategrinder
import re

class Html_Grinder:
	""" Make html table from sudoku + palette. """

	def setup(self):
		""" Define object variables."""
		self.the_sudoku=None
		self.the_palette=None
		self.the_macro_dict={}
		
	def __init__(self,input_sudoku,input_palette):
		""" Make myself given a sudoku. """	
		self.setup()
		self.the_sudoku=input_sudoku
		self.the_palette=input_palette

	def set_htmlstr(self,str):
		self.htmlTemplateStr=str

	def set_sudoku(self,sud):
		self.the_sudoku=sud

	def set_palette(self,pal):
		self.the_palette=pal

	def set_htmlstr_from_file(self,fn):	
		"""Get html template string from filename."""
		f=file(fn)
		fileStr=fn.read()	
		f.close()
		self.set_htmlstr(fileStr)

	def return_html(self,fnStr):
		"""Return colored html from sudoku."""
		self.make_macrostrings_from_sudoku()
		tf=file(fnStr,"r")
		template_str=tf.read()
		tf.close()
		my_grinder=templategrinder.templateGrinder(self.the_macro_dict,template_str)
		return my_grinder.grind()

	def make_html(self,fnStr):
		"""Make colored html from sudoku."""
		print self.return_html(fnStr)
		
	def make_macrostrings_from_sudoku(self):
		number_list=self.the_sudoku.color_list(self.the_palette)
		rowNum=1
		colNum=0
		for row in number_list:
			colNum = 1
			for col in row:
				macroStrColor="Row%dCol%dClr" % (rowNum,colNum)
				macroStrNum="Row%dCol%dNum" % (rowNum,colNum)
				self.the_macro_dict[macroStrColor]=col[1]
				self.the_macro_dict[macroStrNum]=str(col[0])
				colNum += 1
			rowNum += 1


if __name__ == "__main__":
	import sys
	sudokuFil=file(sys.argv[1])
	sudokuStr=sudokuFil.read()
	sudokuFil.close()
	mySudoku=sudoku.A_Sudoku(sudokuStr)
	paletteFil=file(sys.argv[2])
	paletteStr=paletteFil.read()
	paletteFil.close()
	myPalette=palette.A_Palette(paletteStr)
	myGrinder=Html_Grinder(mySudoku,myPalette)
#	myGrinder.make_macrostrings_from_sudoku()
#	print myGrinder.the_macro_dict
	myGrinder.make_html(sys.argv[3])