#!/usr/bin/python
#############################################################################
#
#
# Copyright (C) Charles Shapiro 2006 charles.shapiro@tomshiro.org
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2, or (at your option)
#   any later version.
#
# Palette object
#
# $Id: palette.py,v 1.4 2006/04/28 03:17:52 devel Exp $
#
#############################################################################
import string
import md5
import types

class A_Palette:

	def __init__(self,inThing,isFN=False):
		"""Make myself from input string or dictionary"""
		self.Valid=0
		if types.StringType == type(inThing):
			if isFN==False:
				self.paletteDict=self.fromString(inThing)
			else:
				fil=file(inThing,"r")
				myStr=fil.read()
				fil.close()
				self.paletteDict=self.fromString(myStr)
		if types.DictType == type(inThing):
			self.Valid=1
			self.paletteDict=inThing

	def save_to_file(self,fileName):
	        """Save myself to a file."""
		my_str=str(self)
		outfile=file(fileName,"w")
		outfile.write(my_str)
		outfile.close()

	def get_hash(self):
		"""Return hash of palette. This must exactly match
                the output of md5sum(1) or much wacky fun will ensue."""
		mdh=md5.new()
		mdh.update(str(self))
		retVal=mdh.hexdigest()
		return retVal		

	def fromString(self,p_string):
		""" Make palette list from string """
		retDict={}
		rawList=p_string.split("\n")
		for ii in rawList:
			workList=ii.split()
			if len(workList) > 1:
				retDict[string.atoi(workList[0])]=workList[1]
		self.Valid=1
		return retDict

	def __str__(self):
		retStr=""
		if not self.Valid:
			retStr="Not Valid" 
		if retStr == "":
			keyList=self.paletteDict.keys()
			keyList.sort()
			for ii in keyList:
				retStr += "%d %s\n" % (ii,self.paletteDict[ii])
		return retStr

	def color_for_number(self,num):
		"""Return a color for a number."""
		retVal=""
		if num > 9:
			num = 9
		if num < 1:
			num = 0
			retVal="white"
		if not self.Valid:
			retVal="white"
		if not len(retVal):
			retVal=self.paletteDict[num]
		return retVal
#
# Testing
#
import sys
if __name__ == "__main__":
	myPalette=A_Palette(sys.argv[1],True)
	print myPalette
	print "For 7: " + myPalette.color_for_number(7)
	print "For 12: " + myPalette.color_for_number(12)
	print "For -5: " + myPalette.color_for_number(-5)





