#!/usr/bin/python
#############################################################################
#
# Palette object
#
#############################################################################
import string

class A_Palette:
	def __init__(self,inStr):
		"""Make myself from input string."""
		self.Valid=0
		self.paletteDict=self.fromString(inStr)

	def fromString(self,p_string):
		""" Make palette list from string """
		retDict={}
		rawList=p_string.split("\n")
		for ii in rawList:
			workList=ii.split()
			retDict[string.atoi(workList[0])]=workList[1]
		self.Valid=1
		return retDict

	def __str__(self):
		retStr=""
		if not self.Valid:
			retStr="Not Valid" 
		if retStr == "":
			keyList=self.paletteDict.keys()
			keyList.sort()
			for ii in keyList:
				retStr += "%d %s\n" % (ii,self.paletteDict[ii])
		return retStr

	def color_for_number(self,num):
		"""Return a color for a number."""
		retVal=""
		if num > 9:
			num = 9
		if num < 1:
			num = 1
		if not self.Valid:
			retVal="black"
		if not len(retVal):
			retVal=self.paletteDict[num]
		return retVal
#
# Testing
#
import sys
if __name__ == "__main__":
	inFile=open(sys.argv[1])
	inptStr=inFile.read()
	inFile.close()
	myPalette=A_Palette(inptStr)
	print myPalette
	print "For 7: " + myPalette.color_for_number(7)
	print "For 12: " + myPalette.color_for_number(12)
	print "For -5: " + myPalette.color_for_number(-5)





